
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android WebView 开发教程 / 憋错料</title>

    <meta name="description" content="Android WebView 开发教程 1.WebView的使用 (a). 创建WebView的实例加入到Activity中 WebView webview = new WebView(this); setContentView(webview); 或者在xml中配置WebView &lt;Webview android:layout_width=&quot;match_parent&quot; android:layout_height=&quot;match_parent&quot; &gt; &lt;/Webview&gt; ( ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android WebView 开发教程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>1.WebView的使用</h1>
<p>(a). 创建WebView的实例加入到Activity中</p>
<pre>WebView webview = new WebView(this);
setContentView(webview);  </pre>
<p>或者在xml中配置WebView</p>
<pre>&lt;Webview
    android:layout_width="match_parent"
    android:layout_height="match_parent" &gt;
&lt;/Webview&gt;  </pre>
<p>(b). 访问网页</p>
<pre>webview.loadUrl("https://www.baidu.com/");  </pre>
<h1>2.WebView API使用详解</h1>
<h2><strong>(a). 请求加载网页部分</strong></h2>
<pre>public void loadData (String data, String mimeType, String encoding)  </pre>
<p>加载指定的data数据</p>
<p>参数说明：</p>
<p>data &nbsp;字符串String形式的数据 可以通过base64编码而来</p>
<p>mineType data数据的 MIME类型， e.g. ‘text/html‘</p>
<p>encoding data数据的编码格式</p>
<p>注意：</p>
<p>1.Javascript有同源限制，同源策略限制了一个源中加载文本或者脚本与来自其他源中的数据交互方式。避免这种限制可以使用loadDataWithBaseURL()方法。</p>
<p>2.encoding参数制定data参数是否为base64或者 URL 编码，如果data是base64编码那么 encoding必须填写 "base64“。</p>
<pre>public void loadDataWithBaseURL (String baseUrl, String data, String mimeType, String encoding, String historyUrl)  </pre>
<p>使用baseUrl加载base URL的网页内容，baseUrl解决相关url使用Javascript相同源问题。</p>
<pre>public void loadUrl (String url)  </pre>
<p>加载制定url的网页内容</p>
<pre>public void loadUrl (String url, Map&lt;String, String&gt; additionalHttpHeaders)  </pre>
<p>加载制定url并携带http header数据。</p>

<pre>public void reload ()  </pre>
<p>重新加载页面 &nbsp;<strong>注意：页面所有资源会重新加载</strong></p>

<pre>public void stopLoading ()  </pre>
<p>停止加载页面</p>
<h2><strong>(b). 网页的前进后退</strong></h2>
<p><img src="/img/fz.gif"></p>
<pre>public void goBack ()  // 页面后退
public void goForward ()  // 页面前进
public void goBackOrForward (int steps) // 以当前的index为起始点前进或者后退到历史记录中指定的steps，  如果steps为负数则为后退，正数则为前进
public boolean canGoForward ()  // 判断页面是否能够前进
public boolean canGoBack ()  // 判断页面是否能够后退</pre>
<p><img src="/img/fz.gif"></p>
<h2><strong>(c). JavaScript操作</strong></h2>
<pre>public void addJavascriptInterface (Object object, String name)  </pre>
<p>当网页需要和App进行交互时，可以注入Java对象提供给JavaScritp调用. &nbsp;Java对象提供相应的方法供js使用.</p>
<p>注意：在Android 4.2以下使用这个api会涉及到JavaScript安全问题， javascript可以通过反射这个<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">Java</a>对象的相关类进行攻击。</p>
<p><strong>链接：<a href="http://www.cnblogs.com/renhui/p/5893099.html" rel="external nofollow noreferrer">Android WebView 总结 —— Java和JavaScript交互</a></strong></p>
<p><strong>链接：<a href="http://www.cnblogs.com/renhui/p/5899520.html" rel="external nofollow noreferrer">Android 4.2版本以下使用WebView组件addJavascriptInterface方法存在JS漏洞</a></strong></p>
<pre>public void evaluateJavascript (String script, ValueCallback&lt;String&gt; resultCallback)  </pre>
<p>这个方法在Android 4.4系统引入，因此只能在Android4.4系统中才能使用，提供在当前页面显示上下文中异步执行javascript代码</p>
<p>注意： 这个方法必须在UI线程调用，这个函数的回调也会在UI线程执行。那么在Android4.4一下如何执行javascrit代码呢？可以通过 WebView提供的loadUrl方法：具体格式如下：</p>
<pre>webView.loadUrl("javascript:alert(injectedObject.toString())");  </pre>
<p>其中javascript: 是执行javascript代码的标识 ， 后面是javascript语句。</p>

<pre>public void removeJavascriptInterface (String name)  </pre>
<p>删除addJavascripInterface时对webview注入的java对象. 此方法在不同的Android系统WebView会有问题，会存在失效情况。</p>
<h2><strong>(d). 网页查找功能</strong></h2>
<pre>public void findAllAsync (String find)  </pre>
<p>异步执行查找网页内包含的字符并设置高亮，查找结果会回调.</p>
<pre>public void findNext (boolean forward)  </pre>
<p>查找下一个匹配的字符</p>
<h2><strong>(e). WebView 事件回调监听</strong></h2>
<pre>public void setWebChromeClient (WebChromeClient client)  </pre>
<p>主要通知客户端app加载当前网页的 title，Favicon，progress,javascript dialog等事件，通知客户端处理这些相应的事件。</p>

<pre>public void setWebViewClient (WebViewClient client)  </pre>
<p>主要通知客户端app加载当前网页时的各种时机状态，onPageStart,onPageFinish,onReceiveError等事件。</p>
<h1>3.WebViewClient,WebChromeClient</h1>
<p>WebView 做为承载网页的载体控件，他在网页显示的过程中会产生一些事件，并回调给我们的应用程序，以便我们在网页加载过程中做应用程序想处理的事情。比如说客户端需要显示网页加载的进度、网页加载发生错误等等事件。 WebView提供两个事件回调类给应用层，分别为WebViewClient,WebChromeClient开发者可以继承这两个类，接手相应事件处理。WebViewClient 主要提供网页加载各个阶段的通知，比如网页开始加载onPageStarted，网页结束加载onPageFinished等；WebChromeClient主要提供网页加载过程中提供的数据内容，比如返回网页的title。</p>
<h2>(a).WebViewClient</h2>
<p><strong>--WebViewClient使用</strong></p>
<p>创建WebViewClient实例并设置到WebView对象中，具体代码参考如下：</p>
<p><img src="/img/fz.gif"></p>
<pre>webview.setWebViewClient(new WebViewClient () {
　　@Override
    public void onPageStarted(WebView view, String url, Bitmap favicon) {
       // TODO
    }  

    @Override
    public void onPageFinished(WebView view, String url) {
      // TODO
    }
});  </pre>
<p><img src="/img/fz.gif"></p>
<p><strong><strong>--</strong>WebViewClient API详解</strong></p>
<pre>public boolean shouldOverrideUrlLoading(WebView view, String url)  </pre>
<p>当加载的网页需要重定向的时候就会回调这个函数告知我们应用程序是否需要接管控制网页加载，如果应用程序接管，并且return true意味着程序接管网页加载，如果返回false让webview自己处理。</p>

<p>注意：</p>
<p>(1) 当请求的方式是"POST"方式时这个回调是不会通知的。</p>
<p>(2) 当我们访问的地址需要我们应用程序自己处理的时候，可以在这里截获，比如我们发现跳转到的是一个market的链接，那么我们可以直接跳转到应用市场，或者其他app。</p>

<pre>public void onPageStarted(WebView view, String url, Bitmap favicon)  </pre>
<p>当开始加载访问的url时，会通知应用程序，对每个main frame这个函数只会被调用一次，页面包含iframe 或者framesets 不会另外调用一次onPageStarted，当网页内内嵌的frame 发生改变时也不会调用onPageStarted。</p>
<p>注意： 当我们通过loadUrl的方式重新加载一个网址时候，这时候会先调用onPageStarted再调用shouldOverrideUrlLoading，当我们在打开的这个网址点击一个link，这时候会先调用shouldOverrideUrlLoading 再调用onPageStarted。不过shouldOverrideUrlLoading不一定每次都被调用，只有需要的时候才会被调用。</p>

<pre>public void onPageFinished(WebView view, String url)  </pre>
<p>当加载完当前页面时会通知我们的应用程序，这个函数只有在main frame情况下才会被调用。</p>

<pre>public void onLoadResource(WebView view, String url)  </pre>
<p>通知应用程序WebView即将加载url 制定的资源</p>

<pre>public WebResourceResponse shouldInterceptRequest(WebView view, String url)  </pre>
<p>通知应用程序内核即将加载url制定的资源，应用程序可以返回本地的资源提供给内核，若本地处理返回数据，内核不从网络上获取数据。</p>
<p>注意：这个回调并不一定在UI线程执行，所以我们需要注意在这里操作View或者私有数据相关的动作。如果我们需要改变网页的背景，或者需要实现网页页面颜色定制化的需求，可以在这个回调时机处理。</p>

<pre>public void onReceivedError(WebView view, int errorCode,  String description, String failingUrl)&nbsp;&nbsp;</pre>
<p>当浏览器访问制定的网址发生错误时会通知我们应用程序，比如网络错误。</p>
<p>参数说明：</p>
<p>@param view&nbsp;接收WebViewClient的那个实例，前面看到webView.setWebViewClient(new MyAndroidWebViewClient())，即是这个webview。</p>
<p>@param errorCode 错误号可以在WebViewClient.ERROR_* 里面找到对应的错误名称。</p>
<p>@param description 描述错误的信息</p>
<p>@param failingUrl &nbsp;当前访问失败的url，注意并不一定是我们主url</p>

<p>注意：</p>
<p>在onReceiveError我们可以自定义网页的错误页面。</p>

<pre>public void onFormResubmission(WebView view, Message dontResend, Message resend)  </pre>
<p>如果浏览器需要重新发送POST请求，可以通过这个时机来处理。默认是不重新发送数据。</p>

<pre>public void doUpdateVisitedHistory(WebView view, String url, boolean isReload)  </pre>
<p>通知应用程序可以将当前的url存储在数据库中，意味着当前的访问url已经生效并被记录在内核当中。这个函数在网页加载过程中只会被调用一次。注意网页前进后退并不会回调这个函数。</p>

<pre>public void onReceivedHttpAuthRequest(WebView view, HttpAuthHandler handler, String host, String realm)  </pre>
<p>通知应用程序WebView接收到了一个Http auth的请求，应用程序可以使用supplied 设置webview的响应请求。默认行为是cancel 本次请求。</p>

<pre>public boolean shouldOverrideKeyEvent(WebView view, KeyEvent event)   </pre>
<p>提供应用程序同步一个处理按键事件的机会，菜单快捷键需要被过滤掉。如果返回true，webview不处理该事件，如果返回false， webview会一直处理这个事件，因此在view 链上没有一个父类可以响应到这个事件。默认行为是return false；</p>
<pre>public void onScaleChanged(WebView view, float oldScale, float newScale)  </pre>
<p>通知应用程序webview 要被scale。应用程序可以处理改事件，比如调整适配屏幕。</p>

<h2><strong>(b).WebChromeClient&nbsp;</strong></h2>
<p><strong>--webChromeClient使用</strong></p>
<pre>webView.setWebChromeClient(new WebChromeClient() {});</pre>
<p><strong>--webChromeCilent API详解</strong></p>
<p>创建WebChromeClient实例并设置到WebView对象中，具体代码参考如下：</p>
<pre>public void onProgressChanged(WebView view, int newProgress)  </pre>
<p>通知应用程序当前网页加载的进度。</p>

<pre>public void onReceivedTitle(WebView view, String title)  </pre>
<p>当document 的title变化时，会通知应用程序。注意：这个函数调用时机不确定，有可能很早，有可能很晚，取决于网页把title设置在什么位置，大多数网页一般把title设置到页面的前面，因此很多情况会比较早回调到这个函数。</p>

<pre>public void onReceivedIcon(WebView view, Bitmap icon)  </pre>
<p>当前页面有个新的favicon时候，会回调这个函数。</p>

<pre>public void onShowCustomView(View view, CustomViewCallback callback)  </pre>
<p>通知应用程序webview需要显示一个custom view，主要是用在视频全屏HTML5Video support。</p>
<p>参数说明：</p>
<p>@param view 即将要显示的view</p>
<p>@param callback &nbsp;当view 需要dismiss 则使用这个对象进行回调通知。</p>

<pre>public void onHideCustomView()  </pre>
<p>退出视频通知</p>

<pre>public boolean onCreateWindow(WebView view, boolean isDialog, boolean isUserGesture, Message resultMsg)  </pre>
<p>请求创建一个新的窗口，如果我们应用程序接管这个请求，必须返回true，并且创建一个新的webview来承载主窗口。</p>
<p>如果应用程序不处理，则需要返回false，默认行为和返回false表现一样。</p>
<p>参数说明：</p>
<p>@param view 请求创建新窗口的webview</p>
<p>@param isUserGesture 如果是true，则说明是来自用户收拾操作行为，比如用户点击链接</p>
<p>@param isDialog true 请求创建的新窗口必须是个dialog，而不是全屏的窗口。</p>
<p>@param resultMsg 当webview创建时需要发送一个消息。WebView.WebViewTransport.setWebView(WebView)</p>

<pre>public void onRequestFocus(WebView view) &nbsp;</pre>
<p>webview请求得到focus，发生这个主要是当前webview不是前台状态，是后台webview。</p>

<pre>public void onCloseWindow(WebView window)  </pre>
<p>通知应用程序从关闭传递过来的webview并从view tree中remove。</p>

<pre>public boolean onJsAlert(WebView view, String url, String message, JsResult result)  </pre>
<p>通知应用程序显示javascript alert对话框，如果应用程序返回true内核认为应用程序处理这个消息，返回false，内核自己处理。</p>
<p><strong>注意：</strong><strong>如果我们应用接管处理， 则必须给出result的结果，result.cancel,result.comfirm必须调用其中之后，否则内核会hang住。</strong></p>

<pre>public boolean onJsConfirm(WebView view, String url, String message,  JsResult result)  </pre>
<p>通知应用程序提供confirm 对话框。</p>
<p>参数说明同上onJsAlert</p>

<pre>public boolean onJsBeforeUnload(WebView view, String url, String message,  JsResult result)  </pre>
<p>通知应用程序显示一个对话框，让用户选择是否离开当前页面，这个回调是javascript中的onbeforeunload事件，如果客户端返回true，内核会认为客户端提供对话框。默认行为是return false。</p>
<p>参数说明和之前介绍的onJsAlert()相同。</p>

<pre>public void openFileChooser(ValueCallback&lt;Uri&gt; uploadFile, String acceptType, String capture)  </pre>
<p>这个回调是私有回调， 当页面需要请求打开系统的文件选择器，则会回调这个方法，比如我们需要上传图片，请求拍照，邮件的附件上传等等操作。</p>
<p>如果不实现这个私有API，则上面的请求都将不会执行。</p>

<h1>4.WebSettings</h1>
<p>Android WebView提供展示网页，也提供我们应用程序对网页加载的一些定制，比如我们为了减少网络数据可以设置当前加载的页面不能显示图片。Android 提供管理WebView的一些setting的类WebSettings，在WebView对象被创建时WebSettings对象也会被同时创建，并附有默认的settings值. WebSettings对象可以通过WebView.getSettings()获得。WebSettings的生命周期同WebView生命周期相同，如果WebView被destroy 则WebSettings应该被释放，否则如果使用WebSettings继续再操作的话， 会抛出异常IllegalStateException。</p>

<p><strong>注意：调用WebSettings设置的所有函数是异步制定的，因此我们设置某个状态并不能马上生效。</strong></p>

<h2><strong>(a).WebSettings API详解</strong></h2>
<pre>public synchronized void setLoadsImagesAutomatically(boolean flag)  </pre>
<p>设置当前webview是否需要加载图片，这个标记控制整个webview的状态，并且对所有的资源都采取这种策略。如果设置为false 那么访问的当前网址中的所以图片资源将不会被加载。默认值是true；<strong>通过配置这个方法的标志，可以实现浏览器的无图模式和有图模式的控制。</strong></p>

<pre>public synchronized void setBlockNetworkImage (boolean flag)  </pre>
<p>当getLoadsImagesAutomatically返回true这个方法才有效， 默认值为：false；</p>

<pre>public void setCacheMode(int mode)  </pre>
<p>一个普通网页的加载cache会被检查，内容也会被重新校验，第一次访问网页时，会存储cache到本地，设置策略可以让网页加载方式发生变化，cache模式有如下几种:</p>
<p>LOAD_DEFAULT: 如果我们应用程序没有设置任何cachemode， 这个是默认的cache方式。 加载一张网页会检查是否有cache，如果有并且没有过期则使用本地cache，否则从网络上获取。</p>
<p>LOAD_CACHE_ELSE_NETWORK: 使用cache资源，即使过期了也使用，如果没有cache才从网络上获取。</p>
<p>LOAD_NO_CACHE: 不使用cache 全部从网络上获取</p>
<p>LOAD_CACHE_ONLY: &nbsp;只使用cache上的内容。</p>

<pre>public synchronized void setLayoutAlgorithm(LayoutAlgorithm l) </pre>
<p>NORMAL：正常显示，没有渲染变化。&nbsp;<br />SINGLE_COLUMN：把所有内容放到WebView组件等宽的一列中。&nbsp;&nbsp; //这个是强制的，把网页都挤变形了(基本不推荐使用)&nbsp;<br />NARROW_COLUMNS：可能的话，使所有列的宽度不超过屏幕宽度。 //默认的<br />TEXT_AUTOSIZING: 这个在API 19及之后才能使用，目前不需要了解和使用.</p>

<pre>public void setLoadWithOverviewMode(boolean overview)  </pre>
<p>概览模式的设置，默认指是false。</p>

<pre>public synchronized void setJavaScriptEnabled (boolean flag)  </pre>
<p>默认值是false. &nbsp;如果我们网页需要javascript时，需要开启这个设置，否则网页加载不全。</p>


<h1>5. WebView 使用 TIPS</h1>

<h2><strong>(a).为WebView自定义错误显示界面:</strong></h2>
<p>覆写WebViewClient中的onReceivedError()方法:</p>

<p><img src="/img/fz.gif"></p>
<pre>/**
 * 显示自定义错误提示页面，用一个View覆盖在WebView
 */
protected void showErrorPage() {
    LinearLayout webParentView = (LinearLayout)mWebView.getParent();  

    initErrorPage();
    while (webParentView.getChildCount() &gt; 1) {
        webParentView.removeViewAt(0);
    }
    LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.FILL_PARENT);
    webParentView.addView(mErrorView, 0, lp);
    mIsErrorPage = true;
}
protected void hideErrorPage() {
    LinearLayout webParentView = (LinearLayout)mWebView.getParent();  

    mIsErrorPage = false;
    while (webParentView.getChildCount() &gt; 1) {
        webParentView.removeViewAt(0);
    }
}  

   protected void initErrorPage() {
    if (mErrorView == null) {
        mErrorView = View.inflate(this, R.layout.online_error, null);
        Button button = (Button)mErrorView.findViewById(R.id.online_error_btn_retry);
        button.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                mWebView.reload();
            }
        });
        mErrorView.setOnClickListener(null);
    }
}  

@Override
public void onReceivedError(WebView view, int errorCode, String description, String failingUrl) {
　　mErrorView.setVisibility(View.VISIBLE);
　　super.onReceivedError(view, errorCode, description, failingUrl);
}          =</pre>
<p><img src="/img/fz.gif"></p>
<h2><strong>(b).WebView cookies 清理</strong></h2>
<pre>CookieSyncManager.createInstance(this);
CookieSyncManager.getInstance().startSync();
CookieManager.getInstance().removeSessionCookie();   </pre>
<h2><strong>(c).清理cache和历史记录</strong></h2>

<pre>webView.clearCache(true);
webView.clearHistory();  </pre>
<h2><strong>(d).屏蔽长按事件</strong></h2>
<p><img src="/img/fz.gif"></p>
<pre>mWebView.setOnLongClickListener(new OnLongClickListener() {  

          @Override
          public boolean onLongClick(View v) {
              return true;
          }
});  </pre>
<p><img src="/img/fz.gif"></p>
<h2><strong>(e).Webview保留缩放功能，但是隐藏缩放控价</strong></h2>
<pre>mWebView.getSettings().setSupportZoom(true);
mWebView.getSettings().setBuiltInZoomControls(true);
if (DeviceUtils.hasHoneycomb()) {
　　　　mWebView.getSettings().setDisplayZoomControls(false);  }</pre>
<p><strong>注意：setDisplayZoomControls是在Android 3.0中新增的API.</strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-10 05:13:13 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/html5/" title="html5">html5</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e4%be%8b/" title="实例">实例</a>, <a href="https://www.biecuoliao.com/tag/sdn/" title="sdn">sdn</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%87%e6%bb%a4/" title="过滤">过滤</a>, <a href="https://www.biecuoliao.com/tag/enabled/" title="enabled">enabled</a>, <a href="https://www.biecuoliao.com/tag/%e6%8e%a5%e6%94%b6/" title="接收">接收</a>, <a href="https://www.biecuoliao.com/tag/rri/" title="rri">rri</a>, <a href="https://www.biecuoliao.com/tag/started/" title="started">started</a>, <a href="https://www.biecuoliao.com/tag/linear/" title="linear">linear</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android WebView 开发教程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/138DmA3.html" rel="bookmark">android入门开发教程之网络性能的优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我在麦子学院上android开发的时候,麦子学院android开发老师讲到Android开发过程中经常会涉及到性能优化的问题,应该从基础.网络.测试等各个层面进行整合优化.现在咱们聊聊Android开发之网络性能的优化. 1)避免频繁网络请求 访问server端时,建立连接本身比传输需要跟多的时间,如非必要,不要将一交互可以做的事情分成多次交互(这需要与Server端协调好).有效管理Service 后台服务就相当于一个持续运行的Acitivity,如果开发的程序后台都会一个service不停的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Z0KbDjM.html" rel="bookmark">Android WiFi开发教程（一）&mdash;&mdash;WiFi热点的创建与关闭</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				相对于BlueTooth,WiFi是当今使用最广的一种无线网络传输技术, 几乎所有智能手机.平板电脑和笔记本电脑都支持Wi-Fi上网.因此,掌握基本的WiFI开发技术是非常必要的.本教程将围绕一个小Demo初步与大家一同探讨WiFi开发. 先上效果图   Demo功能比较简单,四个按钮.两个文本和一个列表.功能主要有创建WiFi热点,关闭WiFi热点,搜索WiFi,连接WiFi,数据通讯.源码会在教程结尾提供. 本章节主要介绍WiFi热点的创建和关闭 需要用到的权限 &lt;uses-permissi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NjJPG4.html" rel="bookmark">Android WebView开发常见问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.添加权限:AndroidManifest.xml中必须使用许可&quot;android.permission.INTERNET&quot;,否则会出Web page not available错误. 2.在要Activity中生成一个WebView组件:WebView webView = new WebView(this); 3.设置WebView基本信息: 如果访问的页面中有Javascript,则webview必须设置支持Javascript. webview.getSettings().set			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vDx6LM.html" rel="bookmark">Android WebView 开发详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android WebView 开发详解 1.概览: Android WebView 做为承载网页的载体控件,他在网页显示的过程中会产生一些事件,并回调给我们的应用程序,以便我们在网页加载过程中做应用程序想处理的事情.比如说客户端需要显示网页加载的进度.网页加载发生错误等等事件. WebView提供两个事件回调类给应用层,分别为WebViewClient,WebChromeClient开发者可以继承这两个类,接手相应事件处理.WebViewClient 主要提供网页加载各个阶段的通知,比如网页开			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4peynoM.html" rel="bookmark">Android WebView 开发详解&lpar;一&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处  http://blog.csdn.net/typename/article/details/39030091 powered by meichal zhao 概览: Android WebView在Android平台上是一个特殊的View, 他能用来显示网页,这个类可以被用来在你的app中仅仅显示一张在线的网页,还可以用来开发浏览器.WebView内部实现是采用渲染引擎来展示view的内容,提供网页前进后退,网页放大,缩小,搜索,前端开发者可以使用web inspector(A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyDQyY4.html" rel="bookmark">Android WebView 开发具体解释&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处  http://blog.csdn.net/typename/article/details/39495409 powered by miechal zhao 概览: Android WebView 做为承载网页的载体控件,他在网页显示的过程中会产生一些事件,并回调给我们的应用程序,以便我们在网页载入过程中做应用程序想处理的事情.比方说client须要显示网页载入的进度.网页载入错误发生等等事件. WebView提供两个事件回调类给应用层,分别为WebViewClient,Web			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y2EbX3.html" rel="bookmark">&lbrack;小程序开发&rsqb; 微信小程序内嵌网页web-view开发教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了便于开发者灵活配置小程序,微信小程序开放了内嵌网页能力.这意味着小程序的内容不再局限于pages和large,我们可以借助内嵌网页丰富小程序的内容.下面附上详细的开发教程(含视频操作以及注意事项) 一.小程序内嵌网页web-view教程 1) 微信公众平台,登录小程序账号 2) 左侧-设置-开发设置-业务域名-配置 3) 小程序管理员微信扫码 4) 填写小程序业务域名,域名需ICP备案 5) 下载校检文件上传至服务器指定目录,保存 6) 小程序业务域名配置完成7) 打开微信开发者工具,添加小			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KP6OY3.html" rel="bookmark">Android WebView 开发详解&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处  http://blog.csdn.net/typename/article/details/39495409 powered by meichal zhao 概览: Android WebView 做为承载网页的载体控件,他在网页显示的过程中会产生一些事件,并回调给我们的应用程序,以便我们在网页加载过程中做应用程序想处理的事情.比如说客户端需要显示网页加载的进度.网页加载发生错误等等事件. WebView提供两个事件回调类给应用层,分别为WebViewClient,WebChr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xAknN3.html" rel="bookmark">Android WebView 开发具体解释&lpar;三&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处   http://blog.csdn.net/typename/article/details/40302351 powered by miechal zhao 概览 Android WebView提供展示网页,也提供我们应用程序对网页载入的一些定制,比方我们为了降低网络数据能够设置当前载入的页面不能显示图片,假设是pc网址在pad上訪问我们能够提供用户一种概览模式的浏览方式,能够提供放大网页字体等定制功能. Android 提供管理WebView的一些setting的类WebS			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyQvYM.html" rel="bookmark" class="title">android-gridView item 大小调节</a>
					<div>
						public static int dip2px(Context context, float dpValue) { final float scale = context.getResources( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3OWqg3.html" rel="bookmark" class="title">人月神话阅读笔记07</a>
					<div>
						第1章 焦油坑      焦油坑的意思说明了即使你足够强大,也无法摆脱束搏而沉到坑底.IT项目也是这样,不论是开发大型软件系统还是小型项目,都会遇到诸多复杂的问题和影响因素,项目本身就是一个足够复杂的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QN9WEM.html" rel="bookmark" class="title">const char&ast;&comma; char const&ast;&comma; char&ast;const的区别</a>
					<div>
						Bjarne在他的The C++ Programming Language里面给出过一个助记的方法: 把一个声明从右向左读. char * const cp; ( * 读成 pointer to )  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqoEb0.html" rel="bookmark" class="title">&amp;lt&semi;fieldset&amp;gt&semi;</a>
					<div>
						legend{text-align:center;} &lt;legend&gt;爱好&lt;legend&gt;(为fieldset定义标题) &lt;input type=&quot;checkb ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvwgb3.html" rel="bookmark" class="title">Microsoft Exchange不支持Windows 8问题</a>
					<div>
						问题原因: &quot;由于Windows 8.Window2012不支持的Microsoft Exchange&quot; .   解决方法: 开始运行Regedit.exe,打开注册表然后去到以下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPDPyM.html" rel="bookmark" class="title">第一章：简介</a>
					<div>
						1.1:概述 IPC是进程间通信(interprocess communication)的简称.传统上该术语描述的是运行在某个操作系统上的进程间的各种消息传递(message passing)的方式. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODbkZ4.html" rel="bookmark" class="title">【c&plus;&plus;版数据结构】之双链表的实现（带头结点以及尾节点）</a>
					<div>
						所实现的双链表的结构如下图所示: 双链表的实现,和第一篇文章单链表的实现大致相同点击打开链接 本篇文章在构建节点的同时,初始化构建节点的前驱和后继,具体细节参考下列代码 头文件:DList.h #if ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekNOa4.html" rel="bookmark" class="title">监听键盘的出现和隐藏顶部View值得改变</a>
					<div>
						- (UITextView *)publishTextView { if (!_publishTextView) { UITextView *publishTextView = [[UITextVie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3waYORM.html" rel="bookmark" class="title">MVC&amp;amp&semi;WebFomr对照学习：ajax异步请求</a>
					<div>
						写在前面:由于工作需要,本人刚接触asp.net mvc,虽然webform的项目干过几个.但是也不是很精通.抛开asp.net webform和asp.net mvc的各自优劣和诸多差异先不说.我认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBw7V0.html" rel="bookmark" class="title">QT 调用DLL 实现原理</a>
					<div>
						1)win下动态库调用有关的函数包括: (1)LoadLibrary,装载动态库. (2)GetProcAddress,获取要引入的函数,将符号名或标识号转换为DLL内部地址. (3)FreeLibr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBjJnJM.html" rel="bookmark" class="title">常见标签的全称</a>
					<div>
						div 语义:Division(分隔) span 语义:Span(范围) ol 语义:Ordered List(排序列表) ul 语义:Unordered List(不排序列表) li 语义:List ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1BeP3.html" rel="bookmark" class="title">实训第九天</a>
					<div>
						我们的分词技术采用的是“语言云”的平台,语言技术平台(Language Technology Platform,LTP)是哈工大社会计算与信息检索研究中心历时十年研制的一整套开放中文自然语言处理系统. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Op9Bg4.html" rel="bookmark" class="title">CF&num;212 Two Semiknights Meet</a>
					<div>
						http://codeforces.com/problemset/problem/362/A 题意:两个棋子同时走田字,问是否能相遇.#没什么卵用. 开始没注意两个棋子同时走,当相差距离为2时,不可能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YQJna0.html" rel="bookmark" class="title">解决tableView分割线左边不到边</a>
					<div>
						//分割线不到边 - (void)viewDidLayoutSubviews{ [super viewDidLayoutSubviews]; if ([self.tableView respondsT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdEqy0.html" rel="bookmark" class="title">不完整的简单应用</a>
					<div>
						AppDelegate.m部分 - (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgAmx3.html" rel="bookmark" class="title">无知者无畏，一本写了四年的书</a>
					<div>
						这是一本写了四年的书,写它的时候儿子还没有出生,写完的时候儿子已经三岁了.    太多的感慨,总结起来又似乎只有一句话,那就是无知者无畏.    还记得是2009年的一个下午,在北京OpenParty ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWGaa4.html" rel="bookmark" class="title">P2679 子串</a>
					<div>
						http://www.luogu.org/problem/show?pid=2679 题目描述 有两个仅包含小写英文字母的字符串 A 和 B.现在要从字符串 A 中取出 k 个互不重叠的非空子串,然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K72by0.html" rel="bookmark" class="title">javascript Array数组详解 各种方法</a>
					<div>
						1.数组的声明方法(1): arrayObj = new Array(); //创建一个数组.复制代码 代码如下: var arr1 = new Array(); (2):arrayObj = new ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDn8B73.html" rel="bookmark" class="title">剑指offer&mdash;字符串转换整数</a>
					<div>
						对于这个问题, 本题考查的实际上就是字符串转换成整数的问题,或者说是要你自行实现atoi函数.那如何实现把表示整数的字符串正确地转换成整数呢?以&quot;345&quot;作为例子: 当我们扫描到字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWw1r4.html" rel="bookmark" class="title">windows下ping命令的结果前加上系统的当前时间</a>
					<div>
						ping命令脚本: :top set BACKUPDATE=%date:~0,4%%date:~5,2%%date:~8,2%    获取当前系统的年月日 echo %time% &gt;&gt; f ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
